program replprobit_d2
    version 8.2
    args todo b lnf g negH g1
    tempvar xb lj
    mleval `xb' = `b'

    quietly {
      gen double `lj' = $ML_y1 * normal(`xb') + (1-$ML_y1)*normal(-`xb')
      mlsum `lnf' = ln(`lj')
      if (`todo'==0 | `lnf' >=. ) exit
      
      replace `g1' = $ML_y1 * normalden(`xb')/`lj' - (1-$ML_y1)*normalden(`xb')/`lj'
      mlvecsum `lnf' `g' = `g1', eq(1)
      if (`todo'==1 | `lnf' >=. ) exit
      
      mlmatsum `lnf' `negH' = `g1'*(`g1'+`xb'), eq(1,1)
      }
end 
